'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _plurallTheme = require('plurall-theme');

var _plurallTheme2 = _interopRequireDefault(_plurallTheme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var shadowColor = 'rgba(0, 0, 0, 0.2)';
var disabledShadowColor = 'rgba(0, 0, 0, 0.1)';
var footerBackgroundColor = '#f7f7f7';
var disabledBackgroundColor = '#f7f7f7';
var disabledFontColor = '#b7b7b7';

var Card = function (_PureComponent) {
  _inherits(Card, _PureComponent);

  function Card() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Card);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Card.__proto__ || Object.getPrototypeOf(Card)).call.apply(_ref, [this].concat(args))), _this), _this.renderAlert = function (alert) {
      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          'span',
          {
            className: 'jsx-2960350451' + ' ' + 'alert'
          },
          alert
        ),
        _react2.default.createElement(
          _style2.default,
          {
            id: '2960350451'
          },
          '.alert.jsx-2960350451{position:absolute;right:20px;top:10px;}'
        )
      );
    }, _this.renderBorder = function (border) {
      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement('span', {
          className: _style2.default.dynamic([['2360745321', [border]]]) + ' ' + 'border'
        }),
        _react2.default.createElement(
          _style2.default,
          {
            id: '2360745321',
            dynamic: [border]
          },
          '.border.__jsx-style-dynamic-selector{background:' + border + ';border-radius:8px 0 0 8px;bottom:0;display:inline;height:100%;left:0;position:absolute;top:0;width:10px;}'
        )
      );
    }, _this.renderContent = function () {
      return _react2.default.createElement(
        'div',
        { style: { width: '100%' } },
        _this.props.children
      ) // eslint-disable-line react/destructuring-assignment
      ;
    }, _this.renderFooter = function () {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          paddingFromProps = _this$props.padding,
          renderFooterAction = _this$props.renderFooterAction,
          renderFooterInfo = _this$props.renderFooterInfo;

      var currentShadowColor = disabled ? disabledShadowColor : shadowColor;
      var spacing = renderFooterInfo && renderFooterAction ? 'space-between' : 'center';
      var shouldRenderButton = !disabled && !!renderFooterAction;

      return _react2.default.createElement(
        _plurallTheme2.default.Consumer,
        null,
        function (_ref2) {
          var paddingFromTheme = _ref2.cardPadding;
          return _react2.default.createElement(
            _react.Fragment,
            null,
            _react2.default.createElement(
              'div',
              {
                className: _style2.default.dynamic([['1812531431', [footerBackgroundColor, currentShadowColor, spacing, paddingFromProps || paddingFromTheme]]]) + ' ' + 'footer'
              },
              renderFooterInfo && _react2.default.createElement(
                'div',
                {
                  className: _style2.default.dynamic([['1812531431', [footerBackgroundColor, currentShadowColor, spacing, paddingFromProps || paddingFromTheme]]]) + ' ' + 'info'
                },
                renderFooterInfo()
              ),
              shouldRenderButton && renderFooterAction()
            ),
            _react2.default.createElement(
              _style2.default,
              {
                id: '1812531431',
                dynamic: [footerBackgroundColor, currentShadowColor, spacing, paddingFromProps || paddingFromTheme]
              },
              '.footer.__jsx-style-dynamic-selector{background-color:' + footerBackgroundColor + ';box-shadow:inset 0px 4px 8px -4px ' + currentShadowColor + ';display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-box-pack:' + spacing + ';-webkit-justify-content:' + spacing + ';-ms-flex-pack:' + spacing + ';justify-content:' + spacing + ';padding:' + (paddingFromProps || paddingFromTheme) + ';padding-bottom:20px;padding-top:20px;}.info.__jsx-style-dynamic-selector{line-height:2.4em;}'
            )
          );
        }
      );
    }, _this.renderIcon = function (icon) {
      return _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(
          'div',
          {
            className: 'jsx-1252175599' + ' ' + 'icon'
          },
          icon
        ),
        _react2.default.createElement(
          _style2.default,
          {
            id: '1252175599'
          },
          '.icon.jsx-1252175599{margin-right:20px;}'
        )
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Card, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          alert = _props.alert,
          border = _props.border,
          color = _props.color,
          disabled = _props.disabled,
          hover = _props.hover,
          icon = _props.icon,
          noShadow = _props.noShadow,
          onClick = _props.onClick,
          paddingFromProps = _props.padding,
          radius = _props.radius,
          renderFooterAction = _props.renderFooterAction,
          renderFooterInfo = _props.renderFooterInfo,
          size = _props.size,
          overflow = _props.overflow,
          transparent = _props.transparent,
          dataTestId = _props.dataTestId;


      var classes = (0, _classnames2.default)('card', size, {
        transparent: transparent,
        'card-hover': hover
      });

      var boxShadow = noShadow ? 'none' : '0 2px 2px 0 ' + (disabled ? disabledShadowColor : shadowColor);

      var cursor = onClick ? 'pointer' : '';
      var hasFooter = !!renderFooterAction || !!renderFooterInfo;

      return _react2.default.createElement(
        _plurallTheme2.default.Consumer,
        null,
        function (_ref3) {
          var paddingFromTheme = _ref3.cardPadding;
          return _react2.default.createElement(
            'div',
            { 'data-test-id': 'card-' + dataTestId, onClick: onClick, className: _style2.default.dynamic([['3214425324', [disabled ? disabledBackgroundColor : color, radius, boxShadow, disabled ? disabledFontColor : 'inherit', cursor, overflow, boxShadow, cursor, paddingFromProps || paddingFromTheme]]]) + ' ' + (classes || '')
            },
            border && _this2.renderBorder(border),
            alert && _this2.renderAlert(alert),
            _react2.default.createElement(
              'div',
              {
                className: _style2.default.dynamic([['3214425324', [disabled ? disabledBackgroundColor : color, radius, boxShadow, disabled ? disabledFontColor : 'inherit', cursor, overflow, boxShadow, cursor, paddingFromProps || paddingFromTheme]]]) + ' ' + 'main'
              },
              icon && _this2.renderIcon(icon),
              _this2.renderContent()
            ),
            hasFooter && _this2.renderFooter(),
            _react2.default.createElement(
              _style2.default,
              {
                id: '3214425324',
                dynamic: [disabled ? disabledBackgroundColor : color, radius, boxShadow, disabled ? disabledFontColor : 'inherit', cursor, overflow, boxShadow, cursor, paddingFromProps || paddingFromTheme]
              },
              '*.__jsx-style-dynamic-selector{box-sizing:border-box;}.card.__jsx-style-dynamic-selector{-webkit-align-items:flex-start;-webkit-box-align:flex-start;-ms-flex-align:flex-start;align-items:flex-start;background-color:' + (disabled ? disabledBackgroundColor : color) + ';border-radius:' + radius + ';box-shadow:' + boxShadow + ';box-sizing:border-box;color:' + (disabled ? disabledFontColor : 'inherit') + ';cursor:' + cursor + ';overflow:' + overflow + ';position:relative;-webkit-transition:all 0.3s;transition:all 0.3s;width:100%;}.card-hover.__jsx-style-dynamic-selector:hover{box-shadow:' + boxShadow + ';cursor:' + cursor + ';-webkit-transition:all 0.3s;transition:all 0.3s;}.card.transparent.__jsx-style-dynamic-selector{background:transparent;box-shadow:none;cursor:default;}.main.__jsx-style-dynamic-selector{width:100%;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;padding:' + (paddingFromProps || paddingFromTheme) + ';}.small.__jsx-style-dynamic-selector{padding:5px 5px 5px 15px;}'
            )
          );
        }
      );
    }
  }]);

  return Card;
}(_react.PureComponent);

Card.propTypes = {
  alert: _propTypes2.default.node,
  border: _propTypes2.default.string,
  children: _propTypes2.default.node.isRequired,
  color: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  hover: _propTypes2.default.bool,
  icon: _propTypes2.default.node,
  noShadow: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  padding: _propTypes2.default.string,
  radius: _propTypes2.default.string,
  renderFooterAction: _propTypes2.default.func,
  renderFooterInfo: _propTypes2.default.func,
  size: _propTypes2.default.oneOf(['small', 'normal']),
  overflow: _propTypes2.default.string,
  transparent: _propTypes2.default.bool,
  dataTestId: _propTypes2.default.string
};

Card.defaultProps = {
  color: '#ffffff',
  radius: '8px',
  size: 'normal',
  overflow: 'hidden'
};

exports.default = Card;